Skip to main content
`Ctrl`+`K`

# DMPlexComputeResidualByKey

Compute the local residual for terms matching the input key

## Synopsis

    #include "petscdmplex.h"
    PetscErrorCode DMPlexComputeResidualByKey(DM dm, PetscFormKey key, IS cellIS, PetscReal time, Vec locX, Vec locX_t, PetscReal t, Vec locF, void *user)

Collective

## Input Parameters

- dm - The output `DM`

- key - The `PetscFormKey` indicating what should be integrated

- cellIS - The `IS` giving a set of cells to integrate over

- time - The time, or `PETSC_MIN_REAL` to include implicit terms in a time-independent problems

- locX - The local solution

- locX_t - The time derivative of the local solution, or `NULL` for time-independent problems

- t - The time

- user - An optional user context, passed to the pointwise functions

## Output Parameter

- locF - The local residual

## See Also

`DMPlexComputeJacobianByKey()`, `DMPlexComputeResidualHybridByKey()`, `DMPlexComputeJacobianHybridByKey()`, `PetscFormKey`

## Level

developer

## Location

src/dm/impls/plex/plexfem.c

Index of all DMPlex routines
Table of Contents for all manual pages
Index of all manual pages